%define prefix /opt/kde4

Name:          kdelibs4
Version:       3.80.3
Release:       5%{?dist}%{?kde}
Summary:       K Desktop Environment 4 - Libraries

License:       LGPL
URL:           http://www.kde.org/
Group:         System Environment/Libraries

Source0:       kdelibs-%{version}.tar.bz2
# (hopefully) make KDE 4 coexist peacefully with KDE 3
Patch0:        kdelibs-%{version}-kde4home.diff
# upstream patch by Aaron J. Seigo to fix klauncher assertion failure
Patch1:        kdelibs-3.80.3-fix-klauncher-crash.diff
# upstream patch by Germain Garand to fix khtml segfault
Patch2:        kdelibs-3.80.3-fix-khtml-crash.diff
# upstream patch by Vladimir Kuznetsov to fix the Cancel button in KMessageBox
Patch3:        kdelibs-3.80.3-fix-kmessagebox-cancel.diff
# backported upstream patch by Rolf Eike 'Dakon' Beer to fix KProcIO truncating the received data
Patch4:        kdelibs-3.80.3-fix-kprocio-truncation.diff
# upstream patch by Christoph Cullmann to fix Ctrl+Right and Shift+Right in the KatePart
Patch5:        kdelibs-3.80.3-fix-katepart-shortcuts.diff
# upstream patch by Thiago Macieira to detect QtScript and fix build with Qt 4.3
Patch6:        kdelibs-3.80.3-detect-qtscript.diff
# upstream patch by Alexander Neundorf to fix caching issues in the above fix
Patch7:        kdelibs-3.80.3-fix-qtscript-detection.diff

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cmake >= 2.4.3
BuildRequires: qt4-devel >= 4.2.0 libxslt-devel aspell-devel giflib-devel
BuildRequires: libpng-devel bzip2-devel openssl-devel libacl-devel gettext-devel
BuildRequires: libtiff-devel pcre-devel libxml2-devel cups-devel libjpeg-devel
BuildRequires: zlib-devel krb5-devel libattr-devel gamin-devel

%description
Libraries for the K Desktop Environment 4.
WARNING: This is an experimental snapshot. It probably has many bugs left.
Also, the API and ABI are NOT stable yet.

%package devel
Group:    Development/Libraries
Summary:  Header files for compiling KDE 4 applications
Requires: %{name} = %{version}-%{release}
Requires: qt4-devel >= 4.2.0
## Really all of these?  Eek.  -- Rex
Requires: libxslt-devel aspell-devel giflib-devel
Requires: libpng-devel bzip2-devel openssl-devel libacl-devel gettext-devel
Requires: libtiff-devel pcre-devel libxml2-devel cups-devel libjpeg-devel
Requires: zlib-devel krb5-devel libattr-devel gamin-devel
%description devel
This package includes the header files you will need to compile
applications for KDE 4.
WARNING: This is an experimental snapshot. It probably has many bugs left.
Also, the API and ABI are NOT stable yet.

%prep
%setup -q -n kdelibs-%{version}
%patch0 -p1 -b .kde4home
%patch1 -p3
%patch2 -p3
%patch3 -p3
%patch4 -p3
%patch5 -p3
%patch6 -p3
%patch7 -p3


%build
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$CFLAGS"
mkdir build
cd build
# We need to set QT_QMAKE_EXECUTABLE explicitly because it doesn't find it in
# the obvious place (/usr/bin).
cmake \
    -DCMAKE_INSTALL_PREFIX=%{prefix}         \
    -DCMAKE_BUILD_TYPE=debugfull             \
    -DQT_QMAKE_EXECUTABLE=/usr/bin/qmake-qt4 \
    ../
make %{?_smp_mflags}

%install
rm -rf "$RPM_BUILD_ROOT"
cd build
make install DESTDIR="$RPM_BUILD_ROOT"
mkdir -p "$RPM_BUILD_ROOT"/usr/bin
cd "$RPM_BUILD_ROOT"/usr/bin
ln -s ../..%{prefix}/bin/kde4-config .
%{__mkdir} -p "$RPM_BUILD_ROOT"%{_libdir}/qt4/plugins/designer
# A symlink doesn't seem to work for this purpose.
%{__cp} -p "$RPM_BUILD_ROOT"%{prefix}/lib/kde4/plugins/designer/kdewidgets.so "$RPM_BUILD_ROOT"%{_libdir}/qt4/plugins/designer/kdewidgets.so

## debuginfo fails without eXecute bit set
chmod a+x $RPM_BUILD_ROOT%{prefix}/lib/*
chmod a+x $RPM_BUILD_ROOT%{prefix}/lib/kde4/*


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%clean
rm -rf "$RPM_BUILD_ROOT"


%files
%defattr(-,root,root)
/usr/bin/kde4-config
%{_libdir}/qt4/plugins/designer/kdewidgets.so
%{prefix}
%exclude %{prefix}/include
#%exclude %{prefix}/lib/*so but not %{prefix}/lib/libkdeinit_*so
%exclude %{prefix}/lib/libkaudiodevicelist.so
%exclude %{prefix}/lib/libkde3support.so
%exclude %{prefix}/lib/libkdecore.so
%exclude %{prefix}/lib/libkdefakes.so
%exclude %{prefix}/lib/libkdefx.so
%exclude %{prefix}/lib/libkdeprint_management.so
%exclude %{prefix}/lib/libkdeprint.so
%exclude %{prefix}/lib/libkdesu.so
%exclude %{prefix}/lib/libkdeui.so
%exclude %{prefix}/lib/libkdnssd.so
%exclude %{prefix}/lib/libkhtml.so
%exclude %{prefix}/lib/libkimproxy.so
%exclude %{prefix}/lib/libkio.so
%exclude %{prefix}/lib/libkjsembed.so
%exclude %{prefix}/lib/libkjs.so
%exclude %{prefix}/lib/libkmediaplayer.so
%exclude %{prefix}/lib/libknewstuff.so
%exclude %{prefix}/lib/libknotifyconfig.so
%exclude %{prefix}/lib/libkntlm.so
%exclude %{prefix}/lib/libkparts.so
%exclude %{prefix}/lib/libkrosscore.so
%exclude %{prefix}/lib/libktexteditor.so
%exclude %{prefix}/lib/libkunittest.so
%exclude %{prefix}/lib/libkutils.so
%exclude %{prefix}/lib/libkwalletbackend.so
%exclude %{prefix}/lib/libkwalletclient.so
%exclude %{prefix}/lib/libkxmlcore.so
%exclude %{prefix}/lib/libphononcore.so
%exclude %{prefix}/lib/libphononui.so
%exclude %{prefix}/lib/libsolidifaces.so
%exclude %{prefix}/lib/libsolid.so
%exclude %{prefix}/lib/libsonnetcore.so
%exclude %{prefix}/lib/libsonnetui.so
%exclude %{prefix}/lib/libthreadweaver.so

%files devel
%defattr(-,root,root)
%{prefix}/include
%{prefix}/lib/libkaudiodevicelist.so
%{prefix}/lib/libkde3support.so
%{prefix}/lib/libkdecore.so
%{prefix}/lib/libkdefakes.so
%{prefix}/lib/libkdefx.so
%{prefix}/lib/libkdeprint_management.so
%{prefix}/lib/libkdeprint.so
%{prefix}/lib/libkdesu.so
%{prefix}/lib/libkdeui.so
%{prefix}/lib/libkdnssd.so
%{prefix}/lib/libkhtml.so
%{prefix}/lib/libkimproxy.so
%{prefix}/lib/libkio.so
%{prefix}/lib/libkjsembed.so
%{prefix}/lib/libkjs.so
%{prefix}/lib/libkmediaplayer.so
%{prefix}/lib/libknewstuff.so
%{prefix}/lib/libknotifyconfig.so
%{prefix}/lib/libkntlm.so
%{prefix}/lib/libkparts.so
%{prefix}/lib/libkrosscore.so
%{prefix}/lib/libktexteditor.so
%{prefix}/lib/libkunittest.so
%{prefix}/lib/libkutils.so
%{prefix}/lib/libkwalletbackend.so
%{prefix}/lib/libkwalletclient.so
%{prefix}/lib/libkxmlcore.so
%{prefix}/lib/libphononcore.so
%{prefix}/lib/libphononui.so
%{prefix}/lib/libsolidifaces.so
%{prefix}/lib/libsolid.so
%{prefix}/lib/libsonnetcore.so
%{prefix}/lib/libsonnetui.so
%{prefix}/lib/libthreadweaver.so


%changelog
* Mon Mar 26 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-5
- apply upstream fixes to build with Qt 4.3 Beta

* Sat Mar 24 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-4
- restore minimum version requirements for cmake and qt4-devel
- drop visibility hack (no longer needed with latest qt4 package)
- don't set QT4DIR and PATH anymore, qdbuscpp2xml has been fixed
- apply upstream bugfixes:
- * khtml segfault fix
- * message box cancel button fix
- * kprocio received buffer truncation fix (backported)
- * KatePart keyboard shortcut (Ctrl+Right, Shift+Right) fix

* Mon Mar 05 2007 Rex Dieter <rdieter[AT]fedoraproject.org> 3.80.3-3
- +eXecute perms for %{prefix}/lib/*

* Fri Feb 23 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-2
- apply upstream patch to fix klauncher crash
- hack around Qt 4 being built with no visibility support
- install Qt Designer plugin

* Wed Feb 21 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.3-1
- update to 3.80.3
- update and improve parallel-installability patch
- set QT4DIR and PATH so CMake's direct $QT4DIR/qdbuscpp2xml calls work
- move libkdeinit_*.so from -devel to main package
- symlink kde4-config into /usr/bin so it can be used for path setting

* Wed Nov 29 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 3.80.2-0.4.20061003svn
- dropped -DCMAKE_SKIP_RPATH=TRUE from cmake
- compiling with QA_RPATHS=0x0003; export QA_RPATHS

* Sun Nov 26 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 3.80.2-0.3.20061003svn
- Added foolishly dropped libjpeg-devel, zlib-devel, krb5-devel, libattr-devel again as BR

* Thu Nov 23 2006 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> 3.80.2-0.2.20061003svn
- parallel build support
- added -DCMAKE_SKIP_RPATH=TRUE to cmake to skip rpath
- dropped libjpeg-devel, zlib-devel, krb5-devel, libattr-devel as BR
- dropped duplicate libattr-devel in BR
- spec file cleanups and added clean up in %%install
- fixed missing dependency : libkdeinit_knotify.so

* Sat Oct 07 2006 Kevin Kofler <Kevin@tigcc.ticalc.org> 3.80.2-0.1.20061003svn
- first Fedora RPM (parts borrowed from the OpenSUSE kdelibs 4 RPM and the Fedora kdelibs 3 RPM)
- apply parallel-installability patch
